<template>
  <div>
    <h2>Players</h2>
    <div v-show="isRolesAssigned">
      Toggle show/hide all roles & team
      <button @click="toggleShowAll">{{ toggleButtonText }}</button>
    </div>
    <div class="container">
      <template v-for="player in players" :key="player">
        <PlayerComponent 
        :player="player"
        :is-roles-assigned="isRolesAssigned"
        @show-card="showCard"
        :is-toggle-show="isToggleShow"/>
     
        <hr/>
      </template>
     <button @click="onAssignRoles" v-if="players.length>0 && !isRolesAssigned">Assign</button>
     <button @click="addNewPlayer" v-if="!isRolesAssigned">Add Player</button>    
    </div>

    <template v-if="isAddNewPlayerButtonClicked == true">
      <ModalComponent @close-modal="isAddNewPlayerButtonClicked = false">
        <form @submit="onAddPlayer">
          <label for="player-name">Name:</label>
          <input type="text" v-model="playerName" class="player-name-input" id="player-name">
          <p v-if="isError === true">Please put in a name</p>
          <button>Add</button>
        </form>
      </ModalComponent>
    </template>

    <template v-if="isShowCardButtonClicked == true">
      <ModalComponent @close-modal="isShowCardButtonClicked = false">
        <img :src="selectedPlayer.src">
      </ModalComponent>
    </template>
    
    <button @click="clearDataFromLocalStorage">Clear Data</button>
  </div>
</template>

<script setup>
import PlayerComponent from '../components/PlayerComponent.vue'
import { ref, onMounted, computed } from 'vue';
import ModalComponent from '@/components/ModalComponent.vue';
import { usePlayersStore } from '@/store/players';
import { storeToRefs } from 'pinia';
import cards  from '@/lib/cards.json'

const { addPlayer, assignRoles } = usePlayersStore()

const { players } = storeToRefs(usePlayersStore())


onMounted(() => {
  loadDataFromLocalStorage()
})

const isToggleShow = ref(false)
const toggleButtonText = computed(() => isToggleShow.value ? 'Hide' : 'Show')
const toggleShowAll = () => {
  isToggleShow.value = !isToggleShow.value
}

const isRolesAssigned = ref(false)
let playerName = ''


const isAddNewPlayerButtonClicked = ref(false)
function addNewPlayer(){
  isAddNewPlayerButtonClicked.value = true
}


function onAssignRoles(){
  isRolesAssigned.value = true
  assignRoles(players.value.length)


  players.value.forEach((player) => {
    cards.map((card) => {
      if(player.roleId === card.id){
        player.team = card.team
        player.role = card.name
        player.src = card.src
      }
    })
  })
}
const isError = ref(false)
function onAddPlayer(){
  if(playerName == ''){
    return isError.value = true
  }
  addPlayer(playerName)

  isAddNewPlayerButtonClicked.value = false
  playerName = ''
  saveDataToLocalStorage()
}

function saveDataToLocalStorage() {
  localStorage.setItem('players', JSON.stringify(players.value));
}

function loadDataFromLocalStorage() {
  const data = localStorage.getItem('players');
  if (data) {
    players.value = JSON.parse(data);
  }
  }

function clearDataFromLocalStorage() {
  localStorage.removeItem('players');
  players.value = [];
}

const isShowCardButtonClicked = ref(false)
const selectedPlayer = ref(null)
function showCard (cardId){
  isShowCardButtonClicked.value = true
  players.value.forEach((player) => {
  if(player.roleId === cardId){
    selectedPlayer.value = player
  }
  })
}
</script>

<style scoped>

.container{
  width: 50%;
  margin: 0 auto;
  max-width: 500px;
  border: 1px solid black;
}

hr:last-child{
  display: none;
}

button{
  display: block;
  margin: 0 auto;
  border: 0;
  padding: 10px;
  width: 150px;
  font-weight: bold;
  cursor: pointer;
}

button:first-of-type{
  background-color: #0059b3 ;
  margin: .5em auto;
  color: white;

}

button:nth-of-type(2){
  background-color: transparent ;
  border: 1px solid black;
  margin-bottom: 1em;
}

button:nth-of-type(3){
  background-color: transparent ;
  border: 1px solid black;
  margin-bottom: 1em;
}

.player-name-input {
  margin: 6px;
}

</style>